Bug 47698 - Mono 4.8 does not expose mono-dl.h in public API
Summary: Mono 4.8 does not expose mono-dl.h in public API
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: General (show other bugs)
Version: 4.8.0 (C9)
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2016-11-23 09:36 UTC by Sergey Zhukov
Modified: 2017-10-06 23:34 UTC (History)
4 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Sergey Zhukov 2016-11-23 09:36:41 UTC
File mono-dl.h was included into loader.h in this commit. https://github.com/mono/mono/commit/244124e6170ba0325f82e6545e5fd2b7cc62a788

But file mono-dl.h is not exposed in mono API and when I include loader.h I've got compile error.  

This is the list of files from `utils` directory which are copied to `$prefix/include/mono-2.0` directory. mono-dl.h is not in the list.

https://github.com/mono/mono/blob/master/mono/utils/Makefile.am#L260-L265


And there is following question:
Is it possible to add unit-test which checks mono public API? For example, after mono build enumerate all *.h files in `$prefix/include/mono-2.0` directory and include them dummy `*.c` file and then try to compile it? It should prevent from such API breaks, when some nono-public headers are included into public headers.
Comment 1 Miguel de Icaza [MSFT] 2016-11-28 02:20:58 UTC
Fixed in master, pull request for 4.8.0 here:

https://github.com/mono/mono/pull/4030
Comment 2 Ludovic Henry 2017-10-06 23:34:45 UTC
https://github.com/mono/mono/pull/4025